import os.path
from os import system
from platform import system as psystem
from shutil import copy2
from zlib import error

from plyer import notification
from stegano import exifHeader


def write_text_ph(path_image, text_write):
    image_name = f'{os.path.split(path_image)[1].split(".")[0]}_hex.jpg'
    path_image_new = f'{os.path.join(os.getcwd(), image_name)}'

    copy2(path_image, path_image_new)

    with open(path_image_new, 'ab') as ph:
        ph.write(text_write.encode())

    if psystem() == "Windows":
        notification.notify(message='HEX текст записан!')
    elif psystem() == "Linux":
        command = f'''notify-send "HEX текст записан!"'''
        system(command)


def read_text_ph(path_image):
    with open(path_image, 'rb') as ph:
        ph_content = ph.read()
        offset = ph_content.index(bytes.fromhex('FFD9'))
        ph.seek(offset + 2)
        text = ph.read().decode()
        if text == "":
            return 'В картинке нет текста!'
        else:
            return text


def write_text_exif(path_image, path_image_text, text_write):
    exifHeader.hide(path_image, path_image_text, text_write)
    if psystem() == "Windows":
        notification.notify(message='Exif текст записан!')
    elif psystem() == "Linux":
        command = f'''notify-send "Exif текст записан!"'''
        system(command)


def read_text_exif(path_image):
    try:
        result = exifHeader.reveal(path_image).decode()
        return result
    except error:
        return 'В картинке нет текста!'

